"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _parsimmon = _interopRequireDefault(require("parsimmon"));

var _crap = _interopRequireDefault(require("../crap"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) { return; } var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var SeparatorParser = _parsimmon["default"].string(',').trim(_crap["default"]);

var CollectionCoreLiteralParser = _parsimmon["default"].lazy(function () {
  var TupleParser = require('./tuple')["default"];

  var SpreadParser = _parsimmon["default"].string('...').then(_crap["default"]).then(TupleParser).node('spread');

  var SimpleListParser = _parsimmon["default"].sepBy(TupleParser, SeparatorParser).node('simpleList');

  return _parsimmon["default"].sepBy(_parsimmon["default"].alt(SpreadParser, SimpleListParser), SeparatorParser).map(function (value) {
    return {
      name: 'collectionCore',
      value: value
    };
  });
});

var ComprehensionParser = _parsimmon["default"].lazy(function () {
  var TupleParser = require('./tuple')["default"];

  var ProgramParser = require('../program')["default"];

  return _parsimmon["default"].seq(_parsimmon["default"].string('each').then(_crap["default"]).then(TupleParser), _crap["default"].then(_parsimmon["default"].string('in')).then(_crap["default"].then(TupleParser)), _crap["default"].then(_parsimmon["default"].string('if')).then(_crap["default"].then(TupleParser)).atMost(1), _crap["default"].then(ProgramParser).atMost(1)).map(function (_ref) {
    var _ref2 = _slicedToArray(_ref, 4),
        left = _ref2[0],
        middle = _ref2[1],
        condition = _ref2[2],
        right = _ref2[3];

    var extractionPart = right.length === 1 ? {
      name: 'pipe',
      value: {
        left: middle,
        right: right[0]
      }
    } : middle;
    var extractionPartWithOptionalCondition = condition.length === 1 ? {
      name: 'pipe',
      value: {
        left: extractionPart,
        right: {
          name: 'functionCall',
          value: {
            left: {
              name: 'identifier',
              value: 'filter'
            },
            right: {
              name: 'lambda',
              value: {
                variable: 'input',
                definition: condition[0]
              }
            }
          }
        }
      }
    } : extractionPart;
    var mapPart = {
      name: 'functionCall',
      value: {
        left: {
          name: 'identifier',
          value: 'map'
        },
        right: {
          name: 'lambda',
          value: {
            variable: 'input',
            definition: left
          }
        }
      }
    };
    return {
      name: 'collectionCore',
      value: [{
        name: 'spread',
        value: {
          name: 'parentheses',
          value: {
            name: 'pipe',
            value: {
              left: extractionPartWithOptionalCondition,
              right: mapPart
            }
          }
        }
      }]
    };
  });
});

var _default = _parsimmon["default"].alt(ComprehensionParser, CollectionCoreLiteralParser);

exports["default"] = _default;